/* pilrctst.c:  Test program for PilRC
 *
 * Wes Cherry
 * wesc@ricochet.net
 */


#include "khepera.h"

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <UI/ScrollBar.h>
#include <System/SerialMgr.h>

int kidForm;


DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
	{
	short err;
	EventType e;
	FormType *pfrm;
	short links,rechts,wert,min,max,size;
	Boolean  gekoppelt=false;
	Boolean  reverse=false;
	Boolean  opened=false;
	const FormType frm;
        ScrollBarPtr bar;
	short* refNumP;
	short refNum;
	int Err;
	int nummer;
	char buffer[200];


	if (!cmd) 
		{
		kidForm = Form001;
		FrmGotoForm(kidForm);

	    while(1) 
			{
			EvtGetEvent(&e, 100);
			if (SysHandleEvent(&e)) 
				continue;
			if (MenuHandleEvent((void *)0, &e, &err)) 
				continue;
	
			switch (e.eType) 
				{
				case ctlSelectEvent:
				  if (e.data.ctlSelect.controlID == PushButton001)
				    {
				      if (opened)
					{
					  Err=SerClose(refNum); 
					  if (Err==0)
					    {
					     opened=false; 
					    }
					  
					}
				      else
					{
					  Err=SysLibFind("Serial Library", &refNum);
					  Err=SerOpen (refNum, 0, 9600);
					  if (Err==0)
					    {
					      opened=true;
					    }
					  
					}
				    }
				  if (e.data.ctlSelect.controlID == NormalButton001)
				    {
				      rechts=0;
					  links=0;
					  bar=FrmGetObjectPtr(pfrm,FrmGetObjectIndex(pfrm, Scrollbar002));
					  SclSetScrollBar(bar,rechts+10,0,20,1);
					  bar=FrmGetObjectPtr(pfrm,FrmGetObjectIndex(pfrm, Scrollbar001));
					  SclSetScrollBar(bar,links+10,0,20,1);
					  if (opened==true)
					    {
					      nummer=SerSend (refNum,"D,0,0\n",6, &Err); 
					    }
					  /*FrmAlert(Alertbox001);*/
					/*
					kidForm++;
					if (kidForm > kidFormLast)
						kidForm = kidForm1;
					FrmGotoForm(kidForm); 
					*/
					}
				if (e.data.ctlSelect.controlID == Checkbox001)
				  {
				    if (gekoppelt) 
				      {
					gekoppelt=false;
				      }
				    else gekoppelt=true;
				  }

				if (e.data.ctlSelect.controlID == Checkbox002)
				  {
				    if (reverse) 
				      {
					reverse=false;
				      }
				    else reverse=true;
				  }

				goto Dft;
				break;
				case sclExitEvent/*sclRepeatEvent*/:
				  if (e.data.sclExit.scrollBarID == Scrollbar001)
				    {
				      links=e.data.sclExit.newValue-10;
				      if (gekoppelt==true)
					{
					  if (reverse==false)
					    {
					      rechts=links;
					      wert=rechts+10;
					      
					      bar=FrmGetObjectPtr(pfrm,FrmGetObjectIndex(pfrm, Scrollbar002));
					      
					      SclSetScrollBar(bar,rechts+10,0,20,1);/*,(Short)0,(Short)20,(Short)1,1*/
					}
					  else
					    {
					      rechts=-links;
					       bar=FrmGetObjectPtr(pfrm,FrmGetObjectIndex(pfrm, Scrollbar002));
					      SclSetScrollBar(bar,rechts+10,0,20,1);
					      
					    }

					}
				    }

				  if (e.data.sclExit.scrollBarID == Scrollbar002)
				    {
				      rechts=e.data.sclExit.newValue-10;
				      if (gekoppelt==true)
					{
					  if (reverse==false)
					    {
					      links=rechts;
					      bar=FrmGetObjectPtr(pfrm,FrmGetObjectIndex(pfrm, Scrollbar001));
					      
					      SclSetScrollBar(bar,links+10,0,20,1);
					      
					    }
					  else
					    {
					      links=-rechts;
					      bar=FrmGetObjectPtr(pfrm,FrmGetObjectIndex(pfrm, Scrollbar001));
					      
					      SclSetScrollBar(bar,links+10,0,20,1);
					      
					    }

					}
				    }
					     

				  if (opened==true)
				    {
				      sprintf(buffer,"D,%d,%d\n",links*(-1),rechts*(-1));
				      nummer=SerSend (refNum,buffer,strlen(buffer), &Err); 
				    }

				  break;	

		
			case frmLoadEvent:
		        FrmSetActiveForm(FrmInitForm(e.data.frmLoad.formID));
				break;
	
			case frmOpenEvent:
				pfrm = FrmGetActiveForm();
				FrmDrawForm(pfrm);
				if (e.data.frmLoad.formID == Form001)
					{
					/*
					TableType *ptbl;
	
					ptbl = FrmGetObjectPtr(pfrm, FrmGetObjectIndex(pfrm, kidTable));
	
					TblSetColumnUsable(ptbl, 0, true);
					TblSetColumnUsable(ptbl, 1, true);
					TblSetColumnUsable(ptbl, 2, true);
					TblSetColumnUsable(ptbl, 3, true);
					TblSetColumnUsable(ptbl, 4, true);
					TblSetRowUsable(ptbl, 0, true);
					TblSetRowUsable(ptbl, 1, true);
	
					TblSetItemStyle(ptbl, 0, 0, textTableItem);
					TblSetItemStyle(ptbl, 1, 0, textTableItem);
					TblSetItemStyle(ptbl, 2, 0, textTableItem);
					TblDrawTable(ptbl);
					*/
					}
							
				break;

			case menuEvent:
				FrmAlert(Alertbox001);
				break;

			case appStopEvent:
				return 0;

			default:
Dft:
				if (FrmGetActiveForm())
					FrmHandleEvent(FrmGetActiveForm(), &e);
				}
			}
		}
	return 0;
	}

